<template>
	<div style="margin: 3rem">
		<header style="margin:8rem 6rem 4rem">
      <ReturnButton :offsetArrow="20" :spanTitle="3" title="Regresar" v-on:clickEvent="returnPage" style="margin-bottom:3rem"></ReturnButton>
    </header>
		<!-- COMPONENTE TITULO -->
    <div style="margin:3rem 6rem">
      <app-title Title="HISTORIAL DE DISCOS"> </app-title>
    </div>
		<!-- container -->
    <div style="margin: 5rem 10rem">
			<el-row class="box_content__disk_history" v-loading="loading" element-loading-text="Obteniendo información...">
				<el-col :span="16">
					<el-row class="description__disk_history">
						<el-col :span="1">
							<i class="el-icon-caret-right icon__disk_history"></i>
						</el-col>
						<el-col :span="18">
							<p class="text__disk_history">Ingresa el código de disco, para conocer los materiales que se han copiado en ese soporte.</p>
							<div class="search__disk_history">
								<el-col :span="18">
									<el-input class="input-head" clearable
										placeholder="Buscar" prefix-icon="el-icon-search"
										v-model="diskCode">
									</el-input>
								</el-col> 
								<el-col :span="5" :offset="1" style="text-align: right;">
									<el-button @click="searchMaterialsOfDisk()" type="primary" v-if="diskCode">BUSCAR</el-button>   
									<el-button type="primary" v-else disabled>BUSCAR</el-button>
								</el-col>
							</div>
						</el-col>
					</el-row>
				</el-col>
				<el-col :span="8" style="text-align: right;">
					<img src="../../../assets/images/historial_discos.svg" alt="Historial de Discos" class="img__disk_history">
				</el-col>
			</el-row>
			<hr>
    </div>

		<!-- Modal no hay materiales con el codigo de disco ingresado -->
		<AppModal :show-dialog.sync="materialsNotFound" v-if="materialsNotFound" nameClass="dialog-red" 
			:rutImg="require(`../../../assets/images/alerta.svg`)" sizeImg="80%"  
			:parrafo="'No se encontraron materiales que contengan el código de disco ingresado.'">
		</AppModal>
	</div>
</template>

<script>
import ReturnButton from '@/components/ReturnButton.vue'
import Title from '@/components/Title.vue'
import SearchFilter from '@/components/searchFilter.vue'
import AppModal from '@/components/AppModal.vue'
import { HTTP } from '../../../main.js'

export default {
	components: {
   	'app-title': Title,
		'app-search-filter': SearchFilter,
		ReturnButton,
		AppModal,
	},
	data () {
    return {
			diskCode: '',
			materialsNotFound: false,
			loading: false,
		}
	},
	methods: {
		returnPage() {
      this.$router.push({name: 'recordOfDiscs'})
		},
		searchMaterialsOfDisk () {
			this.loading = true
			let param = this.diskCode
			if(this.diskCode.indexOf('/') !== -1) {
				let characterPosition = this.diskCode.indexOf('/')
				let newParam = this.diskCode.substr(0, characterPosition)+'&'+this.diskCode.substr(characterPosition+1, this.diskCode.length)
				param = newParam
      }
      // RUTA PARA OBTENER TODOS LOS LARGOMETRAJES
			HTTP.get(`materials/searchByDiskCode/${param}`)
			.then((materialsWithoutChapters) => {
        const withoutChapters = materialsWithoutChapters.data.materials
        console.log(withoutChapters, 'withoutChapters')
        // RUTA PARA OBTENER LAS AFILIACIONES TELEVISA
				HTTP.get(`materials/affiliated/searchByDiskCode/byChapter/${param}`)
				.then((affiliatedWithChapters) => {
          const affiliate_withChapters = affiliatedWithChapters.data.materials
          // RUTA PARA OBTENER LOS ENLATADOS CON CAPITULOS
					HTTP.get(`contracts/searchByDiskCode/byChapter/${param}`)
					.then((materialsWithChapters) => {
						const withChapters = materialsWithChapters.data.materials
						const materialsWithDiskCode = withoutChapters.concat(affiliate_withChapters, withChapters)
            const sortMaterialsByCopyDate = materialsWithDiskCode.sort((a, b) => (a.dateOfCopy > b.dateOfCopy) ? 1 : -1)            
						if(materialsWithDiskCode.length > 0){
							this.$router.push({ name: 'listOfMaterialsOnDisk', params: { diskCode: this.diskCode, materials: sortMaterialsByCopyDate}})
						} else {
							this.loading = false
							this.materialsNotFound = true
						}
					})
				})
			})
		},
	}
}
</script>

<style>
	.description__disk_history .icon__disk_history{
		color: #E54E51;
		font-size: 22px;
	}
	.search__disk_history{
		margin-top: 30px;
	}
	.img__disk_history{
		width: 250px;
		margin-top: 100px;
	}
	.box_content__disk_history{
		margin-bottom: 20px;
	}
</style>